function pop = iniBinUniform(o, nindividuals, bitstringlength)
%
% INIBINUNIFORM Initializes binary population randomly with
% uniform distribution.
%
if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose, 
    fprintf('Initialization: PopSize = %d   Bitstring length = %d\n',nindividuals, bitstringlength);
end

pop = (rand(nindividuals, bitstringlength) > 0.5);
