function pop = iniPermTSPNN(o, nindividuals, dm)

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

ncities = size(dm,1);

if o.verbose, 
    fprintf('Init Nearest Neighbor heuristic: PopSize = %d Cities = %d\n',nindividuals, ncities);
    fprintf('Initializing');
end

pop = zeros(nindividuals, ncities);
for i = 1:nindividuals,
    pop(i,:) = bldPermTSPNN(dm);
    if o.verbose, fprintf('.'); end
end

if o.verbose, fprintf('done.\n'); end

