% Clear the workspace
clear;

bitstringlength = 104;
popsize = 20;
pmut = 1/bitstringlength;

o.verbose = 1;
o.MaxFunEvals = 1000;

figure(1); cla; set(gca,'YScale','log'); hold on;

for iter = 1:25,

    % Run local search
    xstart = rand(1,bitstringlength)>0.5;
    [xLS,fxLS,histLS] = minLocalSearchFirstImproving(...
        @fBinRosenbrock, ...
        xstart, ...
        @mutBinSwitchBit, ...
        {}, ...
        {pmut}, ...
        o);


    % Call the evolutionary algorithm for the fBinRosenbrock objective function.
    [xEA, fxEA, histEA] = minEA(...
        @fBinRosenbrock, {}, ...
        @iniBinUniform, {popsize, bitstringlength}, ...
        @selTournament, {popsize}, ...
        @xoverBinUniform, {}, ...
        @mutBinSwitchBit, {pmut}, ...
        @repTournamentOldVsNew, {}, ...
        o);

    
%    [ax,h1,h2] = plotyy(histLS.evals, histLS.fmin, histEA.evals, histEA.fmin, @step, @step);
    steplogy(histLS.evals, histLS.fmin, 'b-');
    steplogy(histEA.evals, histEA.fmin, 'r--');
    drawnow;

end

title('Comparison of LS and EA on Rosenbrock problem using bin represetnation');
xlabel('evaluations');
ylabel('loss function');
legend('LS','EA');
%ylabel(ax(1),'loss function - LS');
%ylabel(ax(2),'loss function - EA');