function sel = selTournament(f, o, n, tsize)
%
% SELTOURNAMENT Tournament selection.
%

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if nargin < 4 | isempty(tsize),
    tsize = 5;
end

if o.verbose,
   fprintf('Tournament selection: Nsel = %d, Tournament size = %d\n', n, tsize);
end

popsize = length(f);

sel = zeros(n, 1);
for i = 1:n,
    ind = ceil(popsize*rand(1,tsize));
    [foo, imin] = min(f(ind));
    sel(i) = ind(imin);
end