function x = xoverBinUniform(xin, o, prob)

if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end
if nargin < 3 || isempty(prob), prob = 0.5; end % Not the probability of crossover, but the probability that the i-th bit comes from the first parent.

if o.verbose,
    fprintf('Uniform Xover ');
end

[N, D] = size(xin);

x1 = xin(randperm(N),:);
x2 = xin(randperm(N),:);
r = rand(N,D);
x = zeros(N, D);
i = (r <= prob);
x(i) = x1(i);
i = (r > prob);
x(i) = x2(i);

if o.verbose, fprintf('done.\n'); end

return;
