function x = xoverRealWeightedAverage(xin, o)
%
% XOVERREALWEIGHTEDAVERAGE Weighted average crossover for real vectors
%
if ~exist('o','var') | isempty(o), o = struct; end
if iscell(o), o = struct(o{:}); end
if ~isfield(o,'verbose'), o.verbose = 0; end

if o.verbose,
    fprintf('Xover Weigh. average ');
end

[N, D] = size(xin);

x1 = xin(randperm(N),:);
x2 = xin(randperm(N),:);
r = rand(N,1);
x1 = x1 .* r(:,ones(1,D));
r = 1-r;
x2 = x2 .* r(:,ones(1,D));

x = x1 + x2;

if o.verbose, fprintf('done.\n'); end

return;
